# DL_PublicKey_EC< EC > Class Template Reference

`#include <eccrypto.h>`

Inheritance diagram for DL_PublicKey_EC< EC >:

List of all members.

## Detailed Description

### template<class EC>
class DL_PublicKey_EC< EC >

EC public key.

Definition at line 142 of file eccrypto.h.

## Public Types
typedef EC::Point | Element
typedef DL_GroupParameters_EC< EC > | GroupParameters
## Public Member Functions
void | Initialize (const DL_GroupParameters_EC< EC > &params, const Element &Q)
void | Initialize (const EC &ec, const Element &G, const Integer &n, const Element &Q)
void | BERDecodePublicKey (BufferedTransformation &bt, bool parametersPresent, size_t size)
| decode subjectPublicKey part of subjectPublicKeyInfo, without the BIT STRING header
void | DEREncodePublicKey (BufferedTransformation &bt) const
| encode subjectPublicKey part of subjectPublicKeyInfo, without the BIT STRING header
bool | Validate (RandomNumberGenerator &rng, unsigned int level) const
| check this object for errors
bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const
void | AssignFrom (const NameValuePairs &source)
bool | SupportsPrecomputation () const
void | Precompute (unsigned int precomputationStorage=16)
| do precomputation
void | LoadPrecomputation (BufferedTransformation &storedPrecomputation)
| retrieve previously saved precomputation
void | SavePrecomputation (BufferedTransformation &storedPrecomputation) const
| save precomputation for later use
const DL_GroupParameters < Element > & | GetAbstractGroupParameters () const
DL_GroupParameters< Element > & | AccessAbstractGroupParameters ()
const DL_FixedBasePrecomputation < Element > & | GetPublicPrecomputation () const
DL_FixedBasePrecomputation < Element > & | AccessPublicPrecomputation ()
bool | operator== (const DL_PublicKeyImpl< DL_GroupParameters_EC< EC > > &rhs) const
virtual const Element & | GetPublicElement () const
virtual void | SetPublicElement (const Element &y)
virtual Element | ExponentiatePublicElement (const Integer &exponent) const
virtual Element | CascadeExponentiateBaseAndPublicElement (const Integer &baseExp, const Integer &publicExp) const
OID | GetAlgorithmID () const
bool | BERDecodeAlgorithmParameters (BufferedTransformation &bt)
bool | DEREncodeAlgorithmParameters (BufferedTransformation &bt) const
const DL_GroupParameters_EC< EC > & | GetGroupParameters () const
DL_GroupParameters_EC< EC > & | AccessGroupParameters ()
void | BERDecode (BufferedTransformation &bt)
| decode this object from a BufferedTransformation, using BER (Basic Encoding Rules)
void | DEREncode (BufferedTransformation &bt) const
| encode this object into a BufferedTransformation, using DER (Distinguished Encoding Rules)
void | Save (BufferedTransformation &bt) const
| save key into a BufferedTransformation
void | Load (BufferedTransformation &bt)
| load key from a BufferedTransformation
virtual void | BEREncode (BufferedTransformation &bt) const
| encode this object into a BufferedTransformation, using BER
virtual void | ThrowIfInvalid (RandomNumberGenerator &rng, unsigned int level) const
| throws InvalidMaterial if this object fails Validate() test
void | DoQuickSanityCheck () const
template<class T>
bool | GetThisObject (T &object) const
| get a copy of this object or a subobject of it
template<class T>
bool | GetThisPointer (T *&p) const
| get a pointer to this object, as a pointer to T
template<class T>
bool | GetValue (const char *name, T &value) const
| get a named value, returns true if the name exists
template<class T>
T | GetValueWithDefault (const char *name, T defaultValue) const
| get a named value, returns the default if the name doesn't exist
std::string | GetValueNames () const
| get a list of value names that can be retrieved
bool | GetIntValue (const char *name, int &value) const
| get a named value with type int
int | GetIntValueWithDefault (const char *name, int defaultValue) const
| get a named value with type int, with default
template<class T>
void | GetRequiredParameter (const char *className, const char *name, T &value) const
void | GetRequiredIntParameter (const char *className, const char *name, int &value) const
## Static Public Member Functions
static void __cdecl | ThrowIfTypeMismatch (const char *name, const std::type_info &stored, const std::type_info &retrieving)
| used by derived classes to check for type mismatch

## Member Function Documentation

bool DL_PublicKeyImpl< DL_GroupParameters_EC< EC > >::Validate | ( | RandomNumberGenerator & | rng,
|  | unsigned int | level |
| ) |  |  | const`[inline, virtual, inherited]`

check this object for errors

Parameters:

  | level | denotes the level of thoroughness: 0 - using this object won't cause a crash or exception (rng is ignored) 1 - this object will probably function (encrypt, sign, etc.) correctly (but may not check for weak keys and such) 2 - make sure this object will function correctly, and do reasonable security checks 3 - do checks that may take a long time

Returns:
  true if the tests pass

Implements CryptoMaterial.

Definition at line 845 of file pubkey.h.

bool DL_PublicKeyImpl< DL_GroupParameters_EC< EC > >::SupportsPrecomputation | ( |  | ) | const`[inline, virtual, inherited]`

Returns:
  whether this object supports precomputation

Reimplemented from CryptoMaterial.

Definition at line 862 of file pubkey.h.

void DL_PublicKeyImpl< DL_GroupParameters_EC< EC > >::Precompute | ( | unsigned int | n = `16` | ) | `[inline, virtual, inherited]`

do precomputation

The exact semantics of Precompute() is varies, but typically it means calculate a table of n objects that can be used later to speed up computation.

Reimplemented from CryptoMaterial.

Definition at line 864 of file pubkey.h.

void ASN1CryptoMaterial< PublicKey >::Load | ( | BufferedTransformation & | bt | ) | `[inline, virtual, inherited]`

Reimplemented from CryptoMaterial.

Reimplemented in InvertibleRSAFunction.

Definition at line 240 of file asn.h.

virtual void ASN1Object::BEREncode | ( | BufferedTransformation & | bt | ) | const`[inline, virtual, inherited]`

encode this object into a BufferedTransformation, using BER

this may be useful if DEREncode() would be too inefficient

Definition at line 1657 of file cryptlib.h.

bool NameValuePairs::GetIntValue | ( | const char * | name,
|  | int & | value |
| ) |  |  | const`[inline, inherited]`

get a named value with type int

used to ensure we don't accidentally try to get an unsigned int or some other type when we mean int (which is the most common case)

Definition at line 282 of file cryptlib.h.

Referenced by InvertibleRWFunction::GenerateRandom(), InvertibleRSAFunction::GenerateRandom(), InvertibleRabinFunction::GenerateRandom(), InvertibleLUCFunction::GenerateRandom(), DL_GroupParameters_IntegerBased::GenerateRandom(), DL_GroupParameters_DSA::GenerateRandom(), and InvertibleESIGNFunction::GenerateRandom().

The documentation for this class was generated from the following files:

- eccrypto.h
- eccrypto.cpp